ptenchik0 2 years ago
commit
9852a8f16a

+ 31 - 0
Bootstrap.php

@@ -0,0 +1,31 @@
+<?php
+namespace reactlogic\liqpay;
+
+use reactlogic\liqpay\Module as LiqPay;
+use Yii;
+use yii\base\BootstrapInterface;
+use yii\base\Application;
+
+class Bootstrap implements BootstrapInterface
+{
+    public function bootstrap($app)
+    {
+        $app->on(Application::EVENT_BEFORE_REQUEST, [$this, 'processModuleUrlRules']);
+    }
+
+    public function processModuleUrlRules($event)
+    {
+        if(is_a(Yii::$app,'yii\web\Application')) {
+            if ( !(Yii::$app->has('urlManager') && Yii::$app->urlManager->enablePrettyUrl) ) return false; // check if this app has this component set up
+
+            if (Yii::$app->hasModule('liqpay') && Yii::$app->getModule('liqpay') instanceof LiqPay) {
+                $module = Yii::$app->getModule('liqpay');
+                if (isset($module->urlRules)) {
+                    $urlManager = Yii::$app->getUrlManager();
+                    $urlManager->addRules($module->urlRules);
+                }
+            }
+        }
+        return true;
+    }
+}

+ 1 - 0
HEAD

@@ -0,0 +1 @@
+ref: refs/heads/master

+ 42 - 0
LiqPayWidget.php

@@ -0,0 +1,42 @@
+<?php
+
+namespace reactlogic\liqpay;
+
+use Yii;
+
+/**
+ * This is just an example.
+ */
+class LiqPayWidget extends \yii\base\Widget
+{
+    /**
+     * LiqPay payment params
+     * See doc: https://www.liqpay.ua/documentation/api/aquiring/checkout/doc
+     * @var array $data
+     */
+    public $data = array();
+
+    /**
+     * paymentForm | paymentLink
+     * @var string $type
+     */
+    public $type = 'paymentForm';
+
+    public $label;
+    public $css_class;
+
+    public function run()
+    {
+        /** @var \reactlogic\liqpay\Module $liqPay */
+        $liqPay = Yii::$app->getModule('liqpay');
+        $model = $liqPay->buildForm($this->data);
+        $model->validate();
+
+        return $this->render($this->type, [
+            'model' => $model,
+            'type' => $this->type,
+            '_label' => $this->label,
+            '_class' => $this->css_class,
+        ]);
+    }
+}

+ 137 - 0
Module.php

@@ -0,0 +1,137 @@
+<?php
+
+namespace reactlogic\liqpay;
+
+use reactlogic\liqpay\models\PaymentForm;
+use yii\base\Module as BaseModule;
+
+class Module extends BaseModule
+{
+    /**
+     * Версия API. Текущее значение - 3
+     *
+     * @var Number $_version *Required
+     */
+    public $_version = 3;
+
+    /**
+     * Публичный ключ - идентификатор магазина. Получить ключ можно в настройках магазина
+     *
+     * @var String $public_key *Required
+     */
+    public $public_key;
+
+    /**
+     * Публичный ключ - идентификатор магазина. Получить ключ можно в настройках магазина
+     *
+     * @var String $private_key
+     */
+    public $private_key;
+
+    /**
+     * Тип операции.
+     *
+     * @var String $action *Required
+     *
+     * Возможные значения:
+     * - `pay` - платеж,
+     * - `hold` - блокировка средств на счету отправителя
+     * - `subscribe` - регулярный платеж
+     * - `paydonate` - пожертвование
+     * - `auth` - предавторизация карты
+     */
+    public $action;
+
+    /**
+     * Сумма платежа.Например: 5, 7.34
+     *
+     * @var Number $amount *Required
+     */
+    public $amount;
+
+    /**
+     * Валюта платежа. Возможные значения: USD, EUR, RUB, UAH
+     *
+     * @var String $currency *Required
+     */
+    public $currency;
+
+    /**
+     * Назначение платежа.
+     *
+     * @var String $description *Required
+     */
+    public $description;
+
+    /**
+     * Уникальный ID покупки в Вашем магазине. Максимальная длина 255 символов.
+     *
+     * @var String $order_id *Required
+     */
+    public $order_id;
+
+    /**
+     * Валюта платежа. Возможные значения: ru, uk, en
+     *
+     * @var String $language *Optional
+     */
+    public $language = 'uk';
+
+    public function init()
+    {
+        parent::init(); // TODO: Change the autogenerated stub
+
+        if (empty($this->order_id)) {
+            $this->order_id = '' . time();
+        }
+
+    }
+
+    public function getUrlRules()
+    {
+        return array(
+            'poss' => 'liqpay/liqpay/index'
+        );
+    }
+
+    public function buildForm(array $data)
+    {
+        $model = new PaymentForm();
+        $model->load($data, '');
+        $model->version = $this->_version;
+        $model->public_key = $this->public_key;
+
+        $model->action = $this->action;
+        $model->amount = $this->amount;
+        $model->currency = $this->currency;
+        $model->description = $this->description;
+        $model->order_id = $this->order_id;
+
+        $model->language = $this->language;
+
+        /*$model->server_url = $this->server_url;
+        $model->result_url = $this->result_url;*/
+
+        return $model;
+    }
+
+    /**
+     * @param $params
+     * @return string
+     */
+    public function getData($params)
+    {
+        return base64_encode(json_encode($params));
+    }
+
+    /**
+     * @param $params
+     * @return string
+     */
+    public function getSignature($params)
+    {
+        $data = $this->getData($params);
+        return base64_encode(sha1($this->private_key . $data . $this->private_key, 1));
+    }
+
+}

+ 48 - 0
README.md

@@ -0,0 +1,48 @@
+ReactLogic LiqPay Module
+========================
+ReactLogic LiqPay Module Desc
+
+Installation
+------------
+
+The preferred way to install this extension is through [composer](http://getcomposer.org/download/).
+
+Either run
+
+```
+php composer.phar require --prefer-dist reactlogic/yii2-reactlogic-liqpay "*"
+```
+
+or add
+
+```
+"reactlogic/yii2-reactlogic-liqpay": "*"
+```
+
+to the require section of your `composer.json` file.
+
+
+Usage
+-----
+
+Once the extension is installed, add to config  :
+```php
+'modules' => [
+    'liqpay' => [
+        'class' => 'reactlogic\liqpay\Module',
+        'public_key' => 'sandbox_i59645978812',
+        'private_key' => 'sandbox_g80VP8wcnWOhpogR6Jjn0LvE6KtIgY6BFnF2ZsRl',
+        'action' => 'paydonate',
+        'amount' =>  null,
+        'currency' => 'USD',
+        'description' => 'Help People (SOS) WAR!',
+        'language' => 'en',
+    ],
+    ...
+]
+```
+
+Then simply use it in your code by  :
+
+```php
+<?= \reactlogic\liqpay\LiqPayWidget::widget(); ?>

+ 24 - 0
composer.json

@@ -0,0 +1,24 @@
+{
+    "name": "reactlogic/yii2-reactlogic-liqpay",
+    "description": "ReactLogic LiqPay Module Desc",
+    "type": "yii2-extension",
+    "keywords": ["yii2","extension","liqpay"],
+    "license": "GPL-3.0",
+    "authors": [
+        {
+            "name": "Oleg",
+            "email": "ptenchik0@gmail.com"
+        }
+    ],
+    "require": {
+        "yiisoft/yii2": "~2.0.0"
+    },
+    "extra": {
+        "bootstrap": "reactlogic\\liqpay\\Bootstrap"
+    },
+    "autoload": {
+        "psr-4": {
+            "reactlogic\\liqpay\\": ""
+        }
+    }
+}

+ 4 - 0
config

@@ -0,0 +1,4 @@
+[core]
+	repositoryformatversion = 0
+	filemode = true
+	bare = true

+ 20 - 0
controllers/LiqpayController.php

@@ -0,0 +1,20 @@
+<?php
+
+namespace reactlogic\liqpay\controllers;
+
+use yii\web\Controller;
+
+class LiqpayController extends Controller
+{
+    /**
+     * Displays homepage.
+     *
+     * @return string
+     */
+    public function actionIndex()
+    {
+        //var_dump($this);
+        return $this->render('index');
+    }
+
+}

+ 1 - 0
description

@@ -0,0 +1 @@
+Unnamed repository; edit this file 'description' to name the repository.

+ 15 - 0
hooks/applypatch-msg.sample

@@ -0,0 +1,15 @@
+#!/bin/sh
+#
+# An example hook script to check the commit log message taken by
+# applypatch from an e-mail message.
+#
+# The hook should exit with non-zero status after issuing an
+# appropriate message if it wants to stop the commit.  The hook is
+# allowed to edit the commit message file.
+#
+# To enable this hook, rename this file to "applypatch-msg".
+
+. git-sh-setup
+commitmsg="$(git rev-parse --git-path hooks/commit-msg)"
+test -x "$commitmsg" && exec "$commitmsg" ${1+"$@"}
+:

+ 24 - 0
hooks/commit-msg.sample

@@ -0,0 +1,24 @@
+#!/bin/sh
+#
+# An example hook script to check the commit log message.
+# Called by "git commit" with one argument, the name of the file
+# that has the commit message.  The hook should exit with non-zero
+# status after issuing an appropriate message if it wants to stop the
+# commit.  The hook is allowed to edit the commit message file.
+#
+# To enable this hook, rename this file to "commit-msg".
+
+# Uncomment the below to add a Signed-off-by line to the message.
+# Doing this in a hook is a bad idea in general, but the prepare-commit-msg
+# hook is more suited to it.
+#
+# SOB=$(git var GIT_AUTHOR_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
+# grep -qs "^$SOB" "$1" || echo "$SOB" >> "$1"
+
+# This example catches duplicate Signed-off-by lines.
+
+test "" = "$(grep '^Signed-off-by: ' "$1" |
+	 sort | uniq -c | sed -e '/^[ 	]*1[ 	]/d')" || {
+	echo >&2 Duplicate Signed-off-by lines.
+	exit 1
+}

+ 114 - 0
hooks/fsmonitor-watchman.sample

@@ -0,0 +1,114 @@
+#!/usr/bin/perl
+
+use strict;
+use warnings;
+use IPC::Open2;
+
+# An example hook script to integrate Watchman
+# (https://facebook.github.io/watchman/) with git to speed up detecting
+# new and modified files.
+#
+# The hook is passed a version (currently 1) and a time in nanoseconds
+# formatted as a string and outputs to stdout all files that have been
+# modified since the given time. Paths must be relative to the root of
+# the working tree and separated by a single NUL.
+#
+# To enable this hook, rename this file to "query-watchman" and set
+# 'git config core.fsmonitor .git/hooks/query-watchman'
+#
+my ($version, $time) = @ARGV;
+
+# Check the hook interface version
+
+if ($version == 1) {
+	# convert nanoseconds to seconds
+	$time = int $time / 1000000000;
+} else {
+	die "Unsupported query-fsmonitor hook version '$version'.\n" .
+	    "Falling back to scanning...\n";
+}
+
+my $git_work_tree;
+if ($^O =~ 'msys' || $^O =~ 'cygwin') {
+	$git_work_tree = Win32::GetCwd();
+	$git_work_tree =~ tr/\\/\//;
+} else {
+	require Cwd;
+	$git_work_tree = Cwd::cwd();
+}
+
+my $retry = 1;
+
+launch_watchman();
+
+sub launch_watchman {
+
+	my $pid = open2(\*CHLD_OUT, \*CHLD_IN, 'watchman -j --no-pretty')
+	    or die "open2() failed: $!\n" .
+	    "Falling back to scanning...\n";
+
+	# In the query expression below we're asking for names of files that
+	# changed since $time but were not transient (ie created after
+	# $time but no longer exist).
+	#
+	# To accomplish this, we're using the "since" generator to use the
+	# recency index to select candidate nodes and "fields" to limit the
+	# output to file names only. Then we're using the "expression" term to
+	# further constrain the results.
+	#
+	# The category of transient files that we want to ignore will have a
+	# creation clock (cclock) newer than $time_t value and will also not
+	# currently exist.
+
+	my $query = <<"	END";
+		["query", "$git_work_tree", {
+			"since": $time,
+			"fields": ["name"],
+			"expression": ["not", ["allof", ["since", $time, "cclock"], ["not", "exists"]]]
+		}]
+	END
+
+	print CHLD_IN $query;
+	close CHLD_IN;
+	my $response = do {local $/; <CHLD_OUT>};
+
+	die "Watchman: command returned no output.\n" .
+	    "Falling back to scanning...\n" if $response eq "";
+	die "Watchman: command returned invalid output: $response\n" .
+	    "Falling back to scanning...\n" unless $response =~ /^\{/;
+
+	my $json_pkg;
+	eval {
+		require JSON::XS;
+		$json_pkg = "JSON::XS";
+		1;
+	} or do {
+		require JSON::PP;
+		$json_pkg = "JSON::PP";
+	};
+
+	my $o = $json_pkg->new->utf8->decode($response);
+
+	if ($retry > 0 and $o->{error} and $o->{error} =~ m/unable to resolve root .* directory (.*) is not watched/) {
+		print STDERR "Adding '$git_work_tree' to watchman's watch list.\n";
+		$retry--;
+		qx/watchman watch "$git_work_tree"/;
+		die "Failed to make watchman watch '$git_work_tree'.\n" .
+		    "Falling back to scanning...\n" if $? != 0;
+
+		# Watchman will always return all files on the first query so
+		# return the fast "everything is dirty" flag to git and do the
+		# Watchman query just to get it over with now so we won't pay
+		# the cost in git to look up each individual file.
+		print "/\0";
+		eval { launch_watchman() };
+		exit 0;
+	}
+
+	die "Watchman: $o->{error}.\n" .
+	    "Falling back to scanning...\n" if $o->{error};
+
+	binmode STDOUT, ":utf8";
+	local $, = "\0";
+	print @{$o->{files}};
+}

+ 8 - 0
hooks/post-update.sample

@@ -0,0 +1,8 @@
+#!/bin/sh
+#
+# An example hook script to prepare a packed repository for use over
+# dumb transports.
+#
+# To enable this hook, rename this file to "post-update".
+
+exec git update-server-info

+ 14 - 0
hooks/pre-applypatch.sample

@@ -0,0 +1,14 @@
+#!/bin/sh
+#
+# An example hook script to verify what is about to be committed
+# by applypatch from an e-mail message.
+#
+# The hook should exit with non-zero status after issuing an
+# appropriate message if it wants to stop the commit.
+#
+# To enable this hook, rename this file to "pre-applypatch".
+
+. git-sh-setup
+precommit="$(git rev-parse --git-path hooks/pre-commit)"
+test -x "$precommit" && exec "$precommit" ${1+"$@"}
+:

+ 49 - 0
hooks/pre-commit.sample

@@ -0,0 +1,49 @@
+#!/bin/sh
+#
+# An example hook script to verify what is about to be committed.
+# Called by "git commit" with no arguments.  The hook should
+# exit with non-zero status after issuing an appropriate message if
+# it wants to stop the commit.
+#
+# To enable this hook, rename this file to "pre-commit".
+
+if git rev-parse --verify HEAD >/dev/null 2>&1
+then
+	against=HEAD
+else
+	# Initial commit: diff against an empty tree object
+	against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
+fi
+
+# If you want to allow non-ASCII filenames set this variable to true.
+allownonascii=$(git config --bool hooks.allownonascii)
+
+# Redirect output to stderr.
+exec 1>&2
+
+# Cross platform projects tend to avoid non-ASCII filenames; prevent
+# them from being added to the repository. We exploit the fact that the
+# printable range starts at the space character and ends with tilde.
+if [ "$allownonascii" != "true" ] &&
+	# Note that the use of brackets around a tr range is ok here, (it's
+	# even required, for portability to Solaris 10's /usr/bin/tr), since
+	# the square bracket bytes happen to fall in the designated range.
+	test $(git diff --cached --name-only --diff-filter=A -z $against |
+	  LC_ALL=C tr -d '[ -~]\0' | wc -c) != 0
+then
+	cat <<\EOF
+Error: Attempt to add a non-ASCII file name.
+
+This can cause problems if you want to work with people on other platforms.
+
+To be portable it is advisable to rename the file.
+
+If you know what you are doing you can disable this check using:
+
+  git config hooks.allownonascii true
+EOF
+	exit 1
+fi
+
+# If there are whitespace errors, print the offending file names and fail.
+exec git diff-index --check --cached $against --

+ 53 - 0
hooks/pre-push.sample

@@ -0,0 +1,53 @@
+#!/bin/sh
+
+# An example hook script to verify what is about to be pushed.  Called by "git
+# push" after it has checked the remote status, but before anything has been
+# pushed.  If this script exits with a non-zero status nothing will be pushed.
+#
+# This hook is called with the following parameters:
+#
+# $1 -- Name of the remote to which the push is being done
+# $2 -- URL to which the push is being done
+#
+# If pushing without using a named remote those arguments will be equal.
+#
+# Information about the commits which are being pushed is supplied as lines to
+# the standard input in the form:
+#
+#   <local ref> <local sha1> <remote ref> <remote sha1>
+#
+# This sample shows how to prevent push of commits where the log message starts
+# with "WIP" (work in progress).
+
+remote="$1"
+url="$2"
+
+z40=0000000000000000000000000000000000000000
+
+while read local_ref local_sha remote_ref remote_sha
+do
+	if [ "$local_sha" = $z40 ]
+	then
+		# Handle delete
+		:
+	else
+		if [ "$remote_sha" = $z40 ]
+		then
+			# New branch, examine all commits
+			range="$local_sha"
+		else
+			# Update to existing branch, examine new commits
+			range="$remote_sha..$local_sha"
+		fi
+
+		# Check for WIP commit
+		commit=`git rev-list -n 1 --grep '^WIP' "$range"`
+		if [ -n "$commit" ]
+		then
+			echo >&2 "Found WIP commit in $local_ref, not pushing"
+			exit 1
+		fi
+	fi
+done
+
+exit 0

+ 169 - 0
hooks/pre-rebase.sample

@@ -0,0 +1,169 @@
+#!/bin/sh
+#
+# Copyright (c) 2006, 2008 Junio C Hamano
+#
+# The "pre-rebase" hook is run just before "git rebase" starts doing
+# its job, and can prevent the command from running by exiting with
+# non-zero status.
+#
+# The hook is called with the following parameters:
+#
+# $1 -- the upstream the series was forked from.
+# $2 -- the branch being rebased (or empty when rebasing the current branch).
+#
+# This sample shows how to prevent topic branches that are already
+# merged to 'next' branch from getting rebased, because allowing it
+# would result in rebasing already published history.
+
+publish=next
+basebranch="$1"
+if test "$#" = 2
+then
+	topic="refs/heads/$2"
+else
+	topic=`git symbolic-ref HEAD` ||
+	exit 0 ;# we do not interrupt rebasing detached HEAD
+fi
+
+case "$topic" in
+refs/heads/??/*)
+	;;
+*)
+	exit 0 ;# we do not interrupt others.
+	;;
+esac
+
+# Now we are dealing with a topic branch being rebased
+# on top of master.  Is it OK to rebase it?
+
+# Does the topic really exist?
+git show-ref -q "$topic" || {
+	echo >&2 "No such branch $topic"
+	exit 1
+}
+
+# Is topic fully merged to master?
+not_in_master=`git rev-list --pretty=oneline ^master "$topic"`
+if test -z "$not_in_master"
+then
+	echo >&2 "$topic is fully merged to master; better remove it."
+	exit 1 ;# we could allow it, but there is no point.
+fi
+
+# Is topic ever merged to next?  If so you should not be rebasing it.
+only_next_1=`git rev-list ^master "^$topic" ${publish} | sort`
+only_next_2=`git rev-list ^master           ${publish} | sort`
+if test "$only_next_1" = "$only_next_2"
+then
+	not_in_topic=`git rev-list "^$topic" master`
+	if test -z "$not_in_topic"
+	then
+		echo >&2 "$topic is already up to date with master"
+		exit 1 ;# we could allow it, but there is no point.
+	else
+		exit 0
+	fi
+else
+	not_in_next=`git rev-list --pretty=oneline ^${publish} "$topic"`
+	/usr/bin/perl -e '
+		my $topic = $ARGV[0];
+		my $msg = "* $topic has commits already merged to public branch:\n";
+		my (%not_in_next) = map {
+			/^([0-9a-f]+) /;
+			($1 => 1);
+		} split(/\n/, $ARGV[1]);
+		for my $elem (map {
+				/^([0-9a-f]+) (.*)$/;
+				[$1 => $2];
+			} split(/\n/, $ARGV[2])) {
+			if (!exists $not_in_next{$elem->[0]}) {
+				if ($msg) {
+					print STDERR $msg;
+					undef $msg;
+				}
+				print STDERR " $elem->[1]\n";
+			}
+		}
+	' "$topic" "$not_in_next" "$not_in_master"
+	exit 1
+fi
+
+<<\DOC_END
+
+This sample hook safeguards topic branches that have been
+published from being rewound.
+
+The workflow assumed here is:
+
+ * Once a topic branch forks from "master", "master" is never
+   merged into it again (either directly or indirectly).
+
+ * Once a topic branch is fully cooked and merged into "master",
+   it is deleted.  If you need to build on top of it to correct
+   earlier mistakes, a new topic branch is created by forking at
+   the tip of the "master".  This is not strictly necessary, but
+   it makes it easier to keep your history simple.
+
+ * Whenever you need to test or publish your changes to topic
+   branches, merge them into "next" branch.
+
+The script, being an example, hardcodes the publish branch name
+to be "next", but it is trivial to make it configurable via
+$GIT_DIR/config mechanism.
+
+With this workflow, you would want to know:
+
+(1) ... if a topic branch has ever been merged to "next".  Young
+    topic branches can have stupid mistakes you would rather
+    clean up before publishing, and things that have not been
+    merged into other branches can be easily rebased without
+    affecting other people.  But once it is published, you would
+    not want to rewind it.
+
+(2) ... if a topic branch has been fully merged to "master".
+    Then you can delete it.  More importantly, you should not
+    build on top of it -- other people may already want to
+    change things related to the topic as patches against your
+    "master", so if you need further changes, it is better to
+    fork the topic (perhaps with the same name) afresh from the
+    tip of "master".
+
+Let's look at this example:
+
+		   o---o---o---o---o---o---o---o---o---o "next"
+		  /       /           /           /
+		 /   a---a---b A     /           /
+		/   /               /           /
+	       /   /   c---c---c---c B         /
+	      /   /   /             \         /
+	     /   /   /   b---b C     \       /
+	    /   /   /   /             \     /
+    ---o---o---o---o---o---o---o---o---o---o---o "master"
+
+
+A, B and C are topic branches.
+
+ * A has one fix since it was merged up to "next".
+
+ * B has finished.  It has been fully merged up to "master" and "next",
+   and is ready to be deleted.
+
+ * C has not merged to "next" at all.
+
+We would want to allow C to be rebased, refuse A, and encourage
+B to be deleted.
+
+To compute (1):
+
+	git rev-list ^master ^topic next
+	git rev-list ^master        next
+
+	if these match, topic has not merged in next at all.
+
+To compute (2):
+
+	git rev-list master..topic
+
+	if this is empty, it is fully merged to "master".
+
+DOC_END

+ 24 - 0
hooks/pre-receive.sample

@@ -0,0 +1,24 @@
+#!/bin/sh
+#
+# An example hook script to make use of push options.
+# The example simply echoes all push options that start with 'echoback='
+# and rejects all pushes when the "reject" push option is used.
+#
+# To enable this hook, rename this file to "pre-receive".
+
+if test -n "$GIT_PUSH_OPTION_COUNT"
+then
+	i=0
+	while test "$i" -lt "$GIT_PUSH_OPTION_COUNT"
+	do
+		eval "value=\$GIT_PUSH_OPTION_$i"
+		case "$value" in
+		echoback=*)
+			echo "echo from the pre-receive-hook: ${value#*=}" >&2
+			;;
+		reject)
+			exit 1
+		esac
+		i=$((i + 1))
+	done
+fi

+ 42 - 0
hooks/prepare-commit-msg.sample

@@ -0,0 +1,42 @@
+#!/bin/sh
+#
+# An example hook script to prepare the commit log message.
+# Called by "git commit" with the name of the file that has the
+# commit message, followed by the description of the commit
+# message's source.  The hook's purpose is to edit the commit
+# message file.  If the hook fails with a non-zero status,
+# the commit is aborted.
+#
+# To enable this hook, rename this file to "prepare-commit-msg".
+
+# This hook includes three examples. The first one removes the
+# "# Please enter the commit message..." help message.
+#
+# The second includes the output of "git diff --name-status -r"
+# into the message, just before the "git status" output.  It is
+# commented because it doesn't cope with --amend or with squashed
+# commits.
+#
+# The third example adds a Signed-off-by line to the message, that can
+# still be edited.  This is rarely a good idea.
+
+COMMIT_MSG_FILE=$1
+COMMIT_SOURCE=$2
+SHA1=$3
+
+/usr/bin/perl -i.bak -ne 'print unless(m/^. Please enter the commit message/..m/^#$/)' "$COMMIT_MSG_FILE"
+
+# case "$COMMIT_SOURCE,$SHA1" in
+#  ,|template,)
+#    /usr/bin/perl -i.bak -pe '
+#       print "\n" . `git diff --cached --name-status -r`
+# 	 if /^#/ && $first++ == 0' "$COMMIT_MSG_FILE" ;;
+#  *) ;;
+# esac
+
+# SOB=$(git var GIT_COMMITTER_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')
+# git interpret-trailers --in-place --trailer "$SOB" "$COMMIT_MSG_FILE"
+# if test -z "$COMMIT_SOURCE"
+# then
+#   /usr/bin/perl -i.bak -pe 'print "\n" if !$first_line++' "$COMMIT_MSG_FILE"
+# fi

+ 128 - 0
hooks/update.sample

@@ -0,0 +1,128 @@
+#!/bin/sh
+#
+# An example hook script to block unannotated tags from entering.
+# Called by "git receive-pack" with arguments: refname sha1-old sha1-new
+#
+# To enable this hook, rename this file to "update".
+#
+# Config
+# ------
+# hooks.allowunannotated
+#   This boolean sets whether unannotated tags will be allowed into the
+#   repository.  By default they won't be.
+# hooks.allowdeletetag
+#   This boolean sets whether deleting tags will be allowed in the
+#   repository.  By default they won't be.
+# hooks.allowmodifytag
+#   This boolean sets whether a tag may be modified after creation. By default
+#   it won't be.
+# hooks.allowdeletebranch
+#   This boolean sets whether deleting branches will be allowed in the
+#   repository.  By default they won't be.
+# hooks.denycreatebranch
+#   This boolean sets whether remotely creating branches will be denied
+#   in the repository.  By default this is allowed.
+#
+
+# --- Command line
+refname="$1"
+oldrev="$2"
+newrev="$3"
+
+# --- Safety check
+if [ -z "$GIT_DIR" ]; then
+	echo "Don't run this script from the command line." >&2
+	echo " (if you want, you could supply GIT_DIR then run" >&2
+	echo "  $0 <ref> <oldrev> <newrev>)" >&2
+	exit 1
+fi
+
+if [ -z "$refname" -o -z "$oldrev" -o -z "$newrev" ]; then
+	echo "usage: $0 <ref> <oldrev> <newrev>" >&2
+	exit 1
+fi
+
+# --- Config
+allowunannotated=$(git config --bool hooks.allowunannotated)
+allowdeletebranch=$(git config --bool hooks.allowdeletebranch)
+denycreatebranch=$(git config --bool hooks.denycreatebranch)
+allowdeletetag=$(git config --bool hooks.allowdeletetag)
+allowmodifytag=$(git config --bool hooks.allowmodifytag)
+
+# check for no description
+projectdesc=$(sed -e '1q' "$GIT_DIR/description")
+case "$projectdesc" in
+"Unnamed repository"* | "")
+	echo "*** Project description file hasn't been set" >&2
+	exit 1
+	;;
+esac
+
+# --- Check types
+# if $newrev is 0000...0000, it's a commit to delete a ref.
+zero="0000000000000000000000000000000000000000"
+if [ "$newrev" = "$zero" ]; then
+	newrev_type=delete
+else
+	newrev_type=$(git cat-file -t $newrev)
+fi
+
+case "$refname","$newrev_type" in
+	refs/tags/*,commit)
+		# un-annotated tag
+		short_refname=${refname##refs/tags/}
+		if [ "$allowunannotated" != "true" ]; then
+			echo "*** The un-annotated tag, $short_refname, is not allowed in this repository" >&2
+			echo "*** Use 'git tag [ -a | -s ]' for tags you want to propagate." >&2
+			exit 1
+		fi
+		;;
+	refs/tags/*,delete)
+		# delete tag
+		if [ "$allowdeletetag" != "true" ]; then
+			echo "*** Deleting a tag is not allowed in this repository" >&2
+			exit 1
+		fi
+		;;
+	refs/tags/*,tag)
+		# annotated tag
+		if [ "$allowmodifytag" != "true" ] && git rev-parse $refname > /dev/null 2>&1
+		then
+			echo "*** Tag '$refname' already exists." >&2
+			echo "*** Modifying a tag is not allowed in this repository." >&2
+			exit 1
+		fi
+		;;
+	refs/heads/*,commit)
+		# branch
+		if [ "$oldrev" = "$zero" -a "$denycreatebranch" = "true" ]; then
+			echo "*** Creating a branch is not allowed in this repository" >&2
+			exit 1
+		fi
+		;;
+	refs/heads/*,delete)
+		# delete branch
+		if [ "$allowdeletebranch" != "true" ]; then
+			echo "*** Deleting a branch is not allowed in this repository" >&2
+			exit 1
+		fi
+		;;
+	refs/remotes/*,commit)
+		# tracking branch
+		;;
+	refs/remotes/*,delete)
+		# delete tracking branch
+		if [ "$allowdeletebranch" != "true" ]; then
+			echo "*** Deleting a tracking branch is not allowed in this repository" >&2
+			exit 1
+		fi
+		;;
+	*)
+		# Anything else (is there anything else?)
+		echo "*** Update hook: unknown type of update to ref $refname of type $newrev_type" >&2
+		exit 1
+		;;
+esac
+
+# --- Finished
+exit 0

+ 6 - 0
info/exclude

@@ -0,0 +1,6 @@
+# git ls-files --others --exclude-from=.git/info/exclude
+# Lines that start with '#' are comments.
+# For a project mostly in C, the following would be a good set of
+# exclude patterns (uncomment them if you want to use them):
+# *.[oa]
+# *~

+ 0 - 0
info/refs


+ 144 - 0
models/PaymentForm.php

@@ -0,0 +1,144 @@
+<?php
+
+namespace reactlogic\liqpay\models;
+
+
+use Yii;
+use yii\base\Model;
+
+class PaymentForm extends Model
+{
+    const ACTION_BUY = 'pay';
+    const ACTION_HOLD = 'hold';
+    const ACTION_SUBSCRIBE = 'subscribe';
+    const ACTION_PAYDONATE = 'paydonate';
+    const ACTION_AUTH = 'auth';
+
+    const CURRENCY_USD = 'USD';
+    const CURRENCY_EUR = 'EUR';
+    const CURRENCY_RUB = 'RUB';
+    const CURRENCY_UAH = 'UAH';
+
+    const LANGUAGE_UK = 'uk';
+    const LANGUAGE_RU = 'ru';
+    const LANGUAGE_EN = 'en';
+
+    public $version;
+    public $public_key;
+    public $action;
+    public $amount;
+    public $currency;
+    public $description;
+    public $order_id;
+    public $language;
+
+
+
+    /**
+     * @return string
+     */
+    public function formName()
+    {
+        return '';
+    }
+
+    /**
+     * @return array
+     */
+    public function rules()
+    {
+        return [
+            [['version', 'public_key', 'action', 'currency', 'description', 'order_id'], 'required'],
+            [['version', 'amount'], 'number'],
+
+            [['public_key', 'description'], 'string'],
+            ['order_id', 'string', 'max' => 255],
+
+            ['currency', 'in', 'range' => array_keys(self::getCurrencyItems())],
+
+            ['action', 'in', 'range' => array_keys(self::getActionItems())],
+            ['language', 'in', 'range' => array_keys(self::getLanguageItems())],
+        ];
+    }
+
+    /**
+     * @param null $key
+     * @return array|null
+     */
+    private static function getActionItems($key = null)
+    {
+        $items = [
+            self::ACTION_BUY => 'pay',
+            self::ACTION_HOLD => 'hold',
+            self::ACTION_SUBSCRIBE => 'subscribe',
+            self::ACTION_PAYDONATE => 'paydonate',
+            self::ACTION_AUTH => 'auth',
+        ];
+
+        if (!is_null($key)) {
+            return isset($items[$key]) ? $items[$key] : null;
+        }
+
+        return $items;
+    }
+
+    /**
+     * @param null $key
+     * @return array|null
+     */
+    public function getCurrencyItems($key = null)
+    {
+        $items = [
+            self::CURRENCY_USD => 'USD',
+            self::CURRENCY_EUR => 'EUR',
+            self::CURRENCY_RUB => 'RUB',
+            self::CURRENCY_UAH => 'UAH',
+        ];
+
+        if (!is_null($key)) {
+            return isset($items[$key]) ? $items[$key] : null;
+        }
+
+        return $items;
+    }
+
+    /**
+     * @param null $key
+     * @return array|null
+     */
+    public function getLanguageItems($key = null)
+    {
+        $items = [
+            self::LANGUAGE_UK => 'UK',
+            self::LANGUAGE_RU => 'RU',
+            self::LANGUAGE_EN => 'EN',
+        ];
+
+        if (!is_null($key)) {
+            return isset($items[$key]) ? $items[$key] : null;
+        }
+
+        return $items;
+    }
+
+    /**
+     * @return mixed
+     * @throws \yii\base\InvalidConfigException
+     */
+    public function getData()
+    {
+        $liqPay = Yii::$app->getModule('liqpay');
+        return $liqPay->getData($this->getAttributes());
+    }
+
+    /**
+     * @return mixed
+     * @throws \yii\base\InvalidConfigException
+     */
+    public function getSignature()
+    {
+        $liqPay = Yii::$app->getModule('liqpay');
+        return $liqPay->getSignature($this->getAttributes());
+    }
+
+}

+ 1 - 0
objects/info/packs

@@ -0,0 +1 @@
+

+ 2 - 0
views/liqpay/index.php

@@ -0,0 +1,2 @@
+<?php
+echo "asdasdasdda";

+ 22 - 0
views/paymentForm.php

@@ -0,0 +1,22 @@
+<?php
+/**
+ * @var \reactlogic\liqpay\models\PaymentForm $model
+ */
+
+use yii\helpers\Html;
+?>
+
+<?php if ($model->hasErrors()): ?>
+    <?= Html::errorSummary($model) ?>
+<?php else: ?>
+    <?= Html::submitButton($_label, ['form'=>'liqPay-form', 'class'=>$_class]) ?>
+    <?= Html::beginForm('https://www.liqpay.ua/api/3/checkout', 'POST', [
+        'accept-charset' => 'utf8',
+        'id' => 'liqPay-form',
+        'formtarget' => '_blank',
+    ]); ?>
+    <?= Html::activeHiddenInput($model, 'data'); ?>
+    <?= Html::activeHiddenInput($model, 'signature'); ?>
+
+    <?= Html::endForm(); ?>
+<?php endif; ?>

+ 15 - 0
views/paymentLink.php

@@ -0,0 +1,15 @@
+<?php
+/**
+ * @var \reactlogic\liqpay\models\PaymentForm $model
+ */
+
+use yii\helpers\Html;
+?>
+
+<?php if ($model->hasErrors()): ?>
+    <?= Html::errorSummary($model) ?>
+<?php else: ?>
+    <?= Html::a($_label, 'https://www.liqpay.ua/api/3/checkout?data='. $model->getData() .'&signature=' . $model->getSignature(), [
+            'class' => $_class
+    ]); ?>
+<?php endif; ?>